<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from lic.texi on 28 April 1999 -->

<TITLE>The Linear Inequality Calculator - Calculator Example</TITLE>
<link href="lic_20.html" rel=Next>
<link href="lic_18.html" rel=Previous>
<link href="lic_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_18.html">previous</A>, <A HREF="lic_20.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC19" HREF="lic_toc.html#TOC19">Calculator Example</A></H2>
<P>
<A NAME="IDX243"></A>
<A NAME="IDX244"></A>
<A NAME="IDX245"></A>
<A NAME="IDX246"></A>
<A NAME="IDX247"></A>

</P>
<P>
The following is a lic script file that generates the code templates to
perform a matrix transpose on a 2D blocked matrix. The matrix size is
<VAR>U1xU2</VAR> and the block size is <VAR>B1xB2</VAR>.  Before executing the
script file, variables <VAR>U1</VAR>, <VAR>U2</VAR>, <VAR>B1</VAR> and <VAR>B2</VAR> should
be set to the appropriate integer values.  This script file is available
in the <CODE>examples/lic</CODE> directory in the SUIF distribution.

</P>

<PRE>
// Need to set U1, U2, B1 and B2 to appropriate integer values before
// calling this script file.
// Size of the matrix = U1xU2
// Size of the blocks that is assigned to each processor = B1xB2

//  The column assignments
//          p1  p2  p1x p2x i1  i2  b1  b2  a1  a2
//           1   2   3   4   5   6   7   8   9  10

// iteration space
// 1 &#60;= i1 &#60;= U1 and 1 &#60;= i2 &#60;= U2 
# iter = { !1 &#60;= @5 &#60;= U1!
           !1 &#60;= @6 &#60;= U1!}

// Data decompositions of array A
// B1*p1 &#60;= a1-1 &#60; B1 + B1*p1 and B2*p2 &#60;= a2-1 &#60; B2 + B2*p2
# dda  = { !B1@1 &#60;=  @9  - 1 &#60; B1 + B1@1!
           !B2@2 &#60;=  @10 - 1 &#60; B2 + B2@2! }

// Data decompositions of array B
// B1*p1 &#60;= b1-1 &#60; B1 + B1*p1 and B2*p2 &#60;= b2-1 &#60; B2 + B2*p2
# ddb  = { !B1@3 &#60;=  @7 - 1 &#60; B1 + B1@3!
           !B2@4 &#60;=  @8 - 1 &#60; B2 + B2@4! }

// Left hand side A[i1][i2] = ...
// i1 = a1 and i2 = a2
# lhs  = { !@5 = @9!
           !@6 = @10! }

// Right hand side  ... = B[i2][i1]
// i2 = b1 and i1 = b2
# rhs  = { !@6 = @7!
           !@5 = @8! }

# res  = { iter
           dda
           ddb
           lhs
           rhs }

// No communication
# prc  = { res 
           !@1 = @3!
           !@2 = @4! }
prc.code(proc1  proc2  p1x p2x i1  i2  b1  b2  a1  a2)

// Communication
# prc  = { res 
           !@1 &#62; @3! }
prc.code(proc1  proc2  p1x p2x i1  i2  b1  b2  a1  a2)

# prc  = { res 
           !@1 &#60; @3! }
prc.code(proc1  proc2  p1x p2x i1  i2  b1  b2  a1  a2)

# prc  = { res 
           !@1 = @3!
           !@2 &#62; @4! }
prc.code(proc1  proc2  p1x p2x i1  i2  b1  b2  a1  a2)

# prc  = { res 
           !@1 = @3!
           !@2 &#60; @4! }
prc.code(proc1  proc2  p1x p2x i1  i2  b1  b2  a1  a2)

end
</PRE>

<P>
<A NAME="IDX248"></A>

</P>
<P>
The results of running this example for a 1000x1000 matrix with square
blocks of 32 in lic is:

</P>
<P>
<A NAME="IDX249"></A>
<A NAME="IDX250"></A>
<A NAME="IDX251"></A>
<A NAME="IDX252"></A>
<A NAME="IDX253"></A>
<A NAME="IDX254"></A>
<A NAME="IDX255"></A>

<PRE>
csh&#62; lic
 &#62; U1 = 1000
1000
 &#62; U2 = 1000
1000
 &#62; B1 = 32
32
 &#62; B2 = 32
32
 &#62; &#60; tst1
# iter = { !1 &#60;= @5 &#60;= U1!
           !1 &#60;= @6 &#60;= U1!}

# dda  = { !B1@1 &#60;=  @9  - 1 &#60; B1 + B1@1!
           !B2@2 &#60;=  @10 - 1 &#60; B2 + B2@2! }

# ddb  = { !B1@3 &#60;=  @7 - 1 &#60; B1 + B1@3!
           !B2@4 &#60;=  @8 - 1 &#60; B2 + B2@4! }

# lhs  = { !@5 = @9!
           !@6 = @10! }

# rhs  = { !@6 = @7!
           !@5 = @8! }

# res  = { iter
           dda
           ddb
           lhs
           rhs }

# prc  = { res
           !@1 = @3!
           !@2 = @4! }
prc.code(proc1  proc2  p1x p2x i1  i2  b1  b2  a1  a2)
if((proc1 &#62;= 0)&#38;&#38;(proc1 &#60;= 31))
   if(proc2 == proc1);
      p1x = proc1;
      p2x = proc1;
      for(i1 = 1+32*proc1; i1 &#60;= MIN( 32+32*proc1, 1000); i1++)
         for(i2 = 1+32*proc1; i2 &#60;= MIN( 32+32*proc1, 1000); i2++)
            b1 = i2;
            b2 = i1;
            a1 = i1;
            a2 = i2;

# prc  = { res
           !@1 &#62; @3! }
prc.code(proc1  proc2  p1x p2x i1  i2  b1  b2  a1  a2)
if((proc1 &#62;= 1)&#38;&#38;(proc1 &#60;= 31))
   if((proc2 &#62;= 0)&#38;&#38;(proc2 &#60;= -1+proc1))
      p1x = proc2;
      p2x = proc1;
      for(i1 = 1+32*proc1; i1 &#60;= MIN( 32+32*proc1, 1000); i1++)
         for(i2 = 1+32*proc2; i2 &#60;= 32+32*proc2; i2++)
            b1 = i2;
            b2 = i1;
            a1 = i1;
            a2 = i2;

# prc  = { res
           !@1 &#60; @3! }
prc.code(proc1  proc2  p1x p2x i1  i2  b1  b2  a1  a2)
if((proc1 &#62;= 0)&#38;&#38;(proc1 &#60;= 30))
   if((proc2 &#62;= 1+proc1)&#38;&#38;(proc2 &#60;= 31))
      p1x = proc2;
      p2x = proc1;
      for(i1 = 1+32*proc1; i1 &#60;= 32+32*proc1; i1++)
         for(i2 = 1+32*proc2; i2 &#60;= MIN( 32+32*proc2, 1000); i2++)
            b1 = i2;
            b2 = i1;
            a1 = i1;
            a2 = i2;

# prc  = { res
           !@1 = @3!
           !@2 &#62; @4! }
prc.code(proc1  proc2  p1x p2x i1  i2  b1  b2  a1  a2)
cannot create code

# prc  = { res
           !@1 = @3!
           !@2 &#60; @4! }
prc.code(proc1  proc2  p1x p2x i1  i2  b1  b2  a1  a2)
cannot create code

end
 &#62; quit
csh&#62;
</PRE>

<P>
<A NAME="IDX256"></A>

</P>
<P>
When the blocks are not square but rectangles, the above script file
will generate the necessary code which is much more complicated. For
example, try using the following parameters.

<PRE>
U1 = 1000
U2 = 1000
B1 = 32
B2 = 80
</PRE>

<P>
<A NAME="IDX257"></A>

</P>
<P>
<A NAME="IDX258"></A>
<A NAME="IDX259"></A>
<A NAME="IDX260"></A>
<A NAME="IDX261"></A>
<A NAME="IDX262"></A>
<A NAME="IDX263"></A>
<A NAME="IDX264"></A>

</P>

<P><HR><P>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_18.html">previous</A>, <A HREF="lic_20.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
</BODY>
</HTML>
